



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Codefoces 277 E. Binary Tree on Plane</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Codefoces 277 E. Binary Tree on Plane</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 05:15:07 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题目链接：<a href="http://codeforces.com/problemset/problem/277/E" rel="external nofollow noreferrer">http://codeforces.com/problemset/problem/277/E</a></p>
<hr />
<p>参考了这篇题解：<a href="http://blog.csdn.net/Sakai_Masato/article/details/50775315" rel="external nofollow noreferrer">http://blog.csdn.net/Sakai_Masato/article/details/50775315</a></p>
<p>没看出来是费用流啊...我好菜啊。</p>
<p>我写得有一点和上面这篇题解不同：在判断是否无解时我直接记录最大流，判断最大流是否等于$n-1$(似乎是等价的...)</p>
<div>
<pre class="prettyprint linenums"> #include&lt;iostream&gt;<br />
 #include&lt;cstdio&gt;<br />
 #include&lt;algorithm&gt;<br />
 #include&lt;vector&gt;<br />
 #include&lt;cstdlib&gt;<br />
 #include&lt;cmath&gt;<br />
 #include&lt;cstring&gt;<br />
 using namespace std;<br />
 #define maxn 1010<br />
 #define inf 0x7fffffff<br />
 #define llg int<br />
 #define sqr(_) ((_)*(_))<br />
 #define yyj(a) freopen(a".in","r",stdin),freopen(a".out","w",stdout);<br />
 llg n,m;

 struct node<br />
 {<br />
     llg u,v,c,next;<br />
     double w;<br />
 };

 struct FLOW<br />
 {<br />
     llg cnt,maxflow,S,T,pre[maxn],N;<br />
     llg head[maxn],dl[maxn*maxn];<br />
     bool bj[maxn];<br />
     double mincost,dis[maxn];<br />
     node e[maxn*maxn];

     void init()<br />
     {<br />
         memset(head,-,sizeof(head));<br />
         mincost=cnt=maxflow=;<br />
         maxflow=; mincost=;<br />
     }

     void link(llg u,llg v,double w,llg c)<br />
     {<br />
         e[cnt].u=u,e[cnt].v=v,e[cnt].w=w,e[cnt].c=c;<br />
         e[cnt].next=head[u],head[u]=cnt++;

         e[cnt].u=v,e[cnt].v=u,e[cnt].w=-w,e[cnt].c=;<br />
         e[cnt].next=head[v],head[v]=cnt++;<br />
     }

     void updata()<br />
     {<br />
         llg f=inf;<br />
         for (llg i=T;i!=S;i=e[pre[i]].u) f=min(f,e[pre[i]].c);<br />
         maxflow+=f;<br />
         for (llg i=T;i!=S;i=e[pre[i]].u)<br />
         {<br />
             e[pre[i]].c-=f;<br />
             e[pre[i]^].c+=f;<br />
             mincost+=(double)f*e[pre[i]].w;<br />
         }<br />
     }

     bool spfa()<br />
     {<br />
         llg u,v;<br />
         double w;<br />
         memset(pre,-,sizeof(pre));<br />
         memset(bj,,sizeof(bj));<br />
         for (llg i=;i&lt;=N;i++) dis[i]=inf;<br />
         llg l=,r=;<br />
         dl[r]=S; bj[S]=; dis[S]=;<br />
         do<br />
         {<br />
             bj[u=dl[++l]]=;<br />
             for (llg i=head[u];i!=-;i=e[i].next)<br />
             {<br />
                 v=e[i].v,w=e[i].w;<br />
                 if (e[i].c &amp;&amp; dis[v]&gt;dis[u]+w)<br />
                 {<br />
                     dis[v]=dis[u]+w;<br />
                     pre[v]=i;<br />
                     if (!bj[v]) bj[v]=,dl[++r]=v;<br />
                 }<br />
             }<br />
         }while (l&lt;r);

         if (pre[T]==-) return ;<br />
         return ;<br />
     }

     void work()<br />
     {<br />
         while (spfa())<br />
             updata();<br />
     }

 }G;

 inline int getint()<br />
 {<br />
     int w=,q=; char c=getchar();<br />
     while((c&lt;'' || c&gt;'') &amp;&amp; c!='-') c=getchar(); if(c=='-') q=,c=getchar();<br />
     while (c&gt;='' &amp;&amp; c&lt;='') w=w*+c-'', c=getchar(); return q ? -w : w;<br />
 }

 struct POINT{double x,y;}po[maxn];

 bool cmp(const POINT&amp;x,const POINT&amp;y) {return x.y==y.y?x.x&lt;y.x:x.y&lt;y.y;}

 double dis(const POINT&amp;x,const POINT&amp;y) {return sqrt(sqr(x.x-y.x)+sqr(x.y-y.y));}

 int main()<br />
 {<br />
     yyj("flow");<br />
     cin&gt;&gt;n;<br />
     G.init();<br />
     G.N=n*+;<br />
     for (llg i=;i&lt;=n;i++) scanf("%lf%lf",&amp;po[i].x,&amp;po[i].y);<br />
     sort(po+,po+n+,cmp);<br />
     reverse(po+,po++n);<br />
     for (llg i=;i&lt;=n;i++)<br />
         for (llg j=i+;j&lt;=n;j++)<br />
             if (po[i].y&gt;po[j].y)<br />
                 G.link(i,j+n,dis(po[i],po[j]),(llg));<br />
     G.S=*n+,G.T=*n+;<br />
     for (llg i=;i&lt;=n;i++)<br />
     {<br />
         G.link(G.S,i,,(llg));<br />
         G.link(i+n,G.T,,(llg));<br />
     }<br />
     G.work();<br />
     if (G.maxflow!=n-) {cout&lt;&lt;-;} else printf("%.9lf",G.mincost);<br />
     return ;<br />
 }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxg3j9y.html">CSS3与页面布局学习总结（一）&mdash;&mdash;概要、选择器、特殊性与刻度单位</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gjr1l9.html">jquery 拖拽，框选的一点积累</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnnzxjq.html">thrift中的超时&lpar;timeout&rpar;坑</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pgog49.html">Wpf DatePicker 水印修改为中文</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q71mpkq.html">HTML DOM随笔</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kgkxj9.html">web前端基础篇⑥</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gnv248.html">opengl 3&period;3 tutorial</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1me6m9.html">学习总结  JDBC</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x3mgn9.html">Hibernate从入门到精通（四）基本映射</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mwxyjq.html">sql语句中left join、 inner join的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x2egg9.html">JavaScript--垃圾回收器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn53j0q.html">MySQL索引和锁</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yygln8.html">tcpdump参数及使用介绍（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljx2oe9.html">php-自动生成sql语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pkk648.html">我们web前端常用的一些Array对象及应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wp1d0q.html">利用filter替换字符串中的空格</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1wvgxq.html">&period;NET MVC中的防CSRF攻击</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j52djq.html">微软BI SSIS 2012 ETL 控件与案例精讲课程学习方式与面试准备详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4jp5xq.html">ScaleIO 1&period;32现在可以免费下载安装使用了&lpar;除生产环境之外&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwljy1l9.html">Kudu-java数据库简单操作</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwvw00r8.html">图解android开发在界面上显示图片</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5710rq.html">java的几种对象&lpar;PO&comma;VO&comma;DAO&comma;BO&comma;POJO，DTO&rpar;解释</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1yyz1q.html">git本地仓库 push到远程仓库出现错误</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rykvj9.html">（3&period;1）mysql备份与恢复之mysqldump</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdyz4v9.html">C&num;基础加强&lpar;1&rpar;之索引器</a>
			</li>
						<li><a href="https://www.batexi.com/a/960d4oy9.html">Spring中bean标签的属性和值：</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1y2ylq.html">【Assembly】-NO&period;88&period;Assembly&period;2&period;滴水逆向&period;1&period;002-【位运算及基础指令】-</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwgv4d8.html">墨刀联合有赞Vant组件库，让你轻松设计出电商原型</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1r42m48.html">&lbrack;pat&rsqb;1068 Find More Coins</a>
			</li>
						<li><a href="https://www.batexi.com/a/q253v2wq.html">cocos2d-x JS 各类点、圆、矩形之间的简单碰撞检测</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
